# -*- encoding : utf-8 -*-
module Mongoid
  module Toggle
    extend ActiveSupport::Concern
    autoload :Version, 'mongoid/toggle/version'

    included do
      def toggle!(field_name)
        process_toggle(field_name)
        save
      end

      def toggle(field_name)
        process_toggle(field_name)
        true
      end

      protected
        def process_toggle(field_name)
          field_definition = self.class.fields[field_name.to_s]

          return false if field_definition.nil?
          return false unless field_definition.type.to_s == 'Boolean'

          write_attribute(field_name, !read_attribute(field_name))
        end
    end
  end
end
